; This software is in the public domain.  There is no warranty.
; Last updated September 23, 2004.
; Programmed by Brandon	Whitehead (tricksterbomber@aol.com)

;------- Identification

        .db     "Farspace"

;------- Table of levels

level_table:
        .dw     lev1
        .dw     lev2
        .dw     boss
  		.dw     _shop
        .dw     lev4
		.dw		ambush6
  		.dw     _shop
        .dw     lev5
        .dw     lev6
  		.dw     _shop
        .dw     lev8
		.dw		ambush9
        .dw     boss2
  		.dw     _shop
        .dw     lev10
		.dw		ambush12
        .dw     lev11
        .dw     _shop
        .dw     final
        .dw     _game_finished

;------- Level data
ambush6: .db		15
		.db     L_SET_POWER,37
        .db     L_SET_FIRERATE,5
        .db     L_SET_MOVETYPE,EM_BOUNCE
        .db     L_SET_MOVEDATA,3,3
		.db		L_IMAGE_STILL
        .dw     img_enemy_1 
        .db     L_INSTALL_ROW,18,19,6,10
		.db		L_GOTO
		.dw		lev1x
        .db     L_END

ambush9: .db		18
		.db     L_SET_POWER,35
        .db     L_SET_FIRERATE,5
        .db     L_SET_MOVETYPE,EM_RAMPAGEWAIT 
		.db		L_IMAGE_STILL
        .dw     img_enemy_5 
        .db     L_INSTALL_ROW,18,19,9,10
		.db		L_GOTO
		.dw		lev1x
        .db     L_END

ambush12: .db		18
		.db     L_SET_POWER,25
        .db     L_SET_FIRERATE,5
        .db     L_SET_MOVETYPE,EM_RAMPAGEINIT
		.db		L_IMAGE_STILL
        .dw     img_enemy_4 
        .db     L_INSTALL_ROW,18,19,9,5
		.db		L_GOTO
		.dw		lev1x
        .db     L_END	

final:  .db     2  ;kill 2 emenies
        .db     L_SET_MOVETYPE,EM_BOSS
        .db     L_SET_POWER,254
        .db     L_SET_MOVEDATA,0,32
        .db     L_IMAGE_STILL
        .dw     deathboss
        .db     L_SET_FIRETYPE,FT_PERIODIC
        .db     L_SET_FIRERATE,65
		.db 	L_SET_FIREPOWER,5
        .db     L_SET_WEAPON,W_HUGE
        .db     L_INSTALL_ONE,90,1

        .db     L_SET_MOVETYPE,EM_BOSS
        .db     L_SET_POWER,200
        .db     L_SET_MOVEDATA,0,32
        .db     L_IMAGE_STILL
        .dw     boss1
        .db     L_SET_FIRETYPE,FT_PERIODIC
        .db     L_SET_FIRERATE,110
        .db     L_SET_WEAPON,W_BIG
		.db 	L_SET_FIREPOWER,2
        .db     L_INSTALL_ONE,90,25
        .db     L_END   

lev11:   .db     12
        .db     L_IMAGE_STILL
        .dw     img_enemy_1
        .db     L_SET_MOVETYPE,EM_BOUNCE
        .db     L_SET_FIRERATE,8
        .db     L_SET_POWER,55
        .db     L_SET_WEAPON,W_ARROW
		.db 	L_SET_FIREPOWER,2
        .db     L_INSTALL_ROW,18,18,6,15
		.db 	L_SET_FIREPOWER,1
        .db     L_SET_MOVETYPE,EM_PATTERNSTART
        .db     L_SET_MOVEDATA
        .dw     figure_eight_pattern
        .db     L_INSTALL_ROW,18,34,6,15       
	    .db     L_END

lev10:  .db     18
        .db     L_SET_MOVETYPE,EM_SWOOPWAIT
        .db     L_IMAGE_STILL
        .dw     img_enemy_2 
        .db     L_INSTALL_ROW,18,18,4,20
        .db     L_SET_POWER,35
        .db     L_SET_FIRERATE,22  
        .db     L_IMAGE_STILL
        .dw     img_bomber
        .db     L_SET_FIRERATE,1
        .db     L_SET_MOVETYPE,EM_PATTERNSTART
        .db     L_SET_MOVEDATA
        .dw     zigzag_pattern
        .db     L_SET_WEAPON,W_NORMAL
        .db     L_SET_POWER,45
        .db     L_INSTALL_ROW,1,18,14,15
        .db     L_END

boss2:   .db     3
        .db     L_SET_MOVETYPE,EM_BOSS
        .db     L_SET_POWER,254
        .db     L_SET_MOVEDATA,0,31
        .db     L_IMAGE_STILL
        .dw     boss1
        .db     L_SET_FIRETYPE,FT_PERIODIC
		.db		L_SET_WEAPON,W_DOUBLE
        .db     L_SET_FIRERATE,64
        .db     L_SET_WEAPON,W_BIG
		.db		L_INSTALL_ONE,90,1
        .db     L_SET_POWER,125
		.db		L_INSTALL_ONE,90,13
        .db     L_SET_POWER,62
		.db		L_INSTALL_ONE,90,25
		.db		L_END

lev8:   .db     10
        .db     L_IMAGE_STILL
        .dw     img_bomber
        .db     L_SET_MOVETYPE,EM_SWOOPWAIT
        .db     L_SET_FIRERATE,4
        .db     L_SET_POWER,60
        .db     L_SET_WEAPON,W_ARROW
        .db     L_INSTALL_ROW,18,17,10,6
        .db     L_END

lev6:   .db     12
        .db     L_IMAGE_STILL
        .dw     img_enemy_2 
        .db     L_SET_POWER,25
        .db     L_INSTALL_ROW,18,18,5,10

        .db     L_SET_POWER,18
        .db     L_SET_MOVETYPE,EM_PATTERNSTART
        .db     L_SET_MOVEDATA
        .dw     circle_pattern
        .db     L_IMAGE_STILL
        .dw     img_bomber
        .db     L_SET_FIRERATE,2
		.db		L_SET_FIREPOWER,2
        .db     L_SET_WEAPON,W_NORMAL
        .db     L_INSTALL_ROW,1,18,7,15
        .db     L_END


lev5:   .db     18
        .db     L_SET_POWER,35
        .db     L_IMAGE_STILL
        .dw     img_enemy_3
        .db     L_SET_WEAPON,W_NORMAL
        .db     L_SET_FIRERATE,4
		.db		L_SET_MOVETYPE,EM_PATTERNSTART
		.db		L_SET_MOVEDATA
		.dw		figure_eight_pattern
		.db     L_INSTALL_ROW,26,2,3,10
        .db     L_INSTALL_ROW,26,22,3,10
        .db     L_INSTALL_ROW,66,2,3,10
        .db     L_INSTALL_ROW,66,22,3,10
        .db     L_INSTALL_ROW,17,7,3,40
        .db     L_INSTALL_ROW,17,17,3,40
        .db     L_END

lev4:   .db     18
        .db     L_SET_POWER,25
        .db     L_IMAGE_STILL
        .dw     img_enemy_4
lev4x:  .db     L_INSTALL_ROW,26,2,3,10
        .db     L_INSTALL_ROW,26,22,3,10
        .db     L_IMAGE_STILL
        .dw     img_enemy_5
        .db     L_INSTALL_ROW,66,2,3,10
        .db     L_INSTALL_ROW,66,22,3,10
		.db		L_IMAGE_STILL
        .dw     img_enemy_2
        .db     L_INSTALL_ROW,17,7,3,40
        .db     L_INSTALL_ROW,17,17,3,40
        .db     L_END

boss:   .db     9
        .db     L_SET_POWER,15
        .db     L_IMAGE_STILL
        .dw     img_enemy_4
        .db     L_INSTALL_ROW,21,16,8,10

        .db     L_SET_MOVETYPE,EM_BOSS
        .db     L_SET_POWER,125
        .db     L_SET_MOVEDATA,0,32
        .db     L_IMAGE_STILL
        .dw     boss1
        .db     L_SET_FIRETYPE,FT_PERIODIC
        .db     L_SET_FIRERATE,64
        .db     L_SET_WEAPON,W_DOUBLE
        .db     L_INSTALL_ONE,90,1
        .db     L_END

lev1:   .db     17
        .db     L_SET_POWER,3
        .db     L_SET_FIRERATE,1
        .db     L_IMAGE_STILL
        .dw     img_enemy_1
        .db     L_INSTALL_ROW,21,2,8,10

lev1x:  .db		L_SET_MOVETYPE,EM_PATTERNSTART
		.db		L_SET_MOVEDATA
		.dw		circle_pattern
		.db     L_SET_POWER,4
        .db     L_SET_FIRERATE,5 
        .db     L_IMAGE_STILL
        .dw     img_enemy_2 
        .db     L_INSTALL_ROW,18,19,9,10

        .db     L_END

lev2:   .db     14
        .db     L_SET_POWER,12
        .db     L_SET_MOVETYPE,EM_PATTERNSTART
        .db     L_SET_MOVEDATA
        .dw     zigzag_pattern
        .db     L_IMAGE_STILL
        .dw     img_bomber
        .db     L_SET_FIRERATE,3
        .db     L_SET_WEAPON,W_SEMIAIM
        .db     L_INSTALL_ROW,1,18,5,15

        .db     L_SET_MOVETYPE,EM_STANDARD
        .db     L_GOTO
        .dw     lev1x
                
_shop:  .db     0
        .db     L_SHOP

_game_finished:
        .db     0
        .db     L_GAMEEND

;------- Enemy movement patterns
zigzag_pattern:
        .db     32,0,4
zigzag_loop:
        .db     16,12,12
        .db     16,12,-12
        .db     16,12,12
        .db     16,12,-12
        .db     16,12,12
        .db     16,12,-12
        .db     16,0,-16
        .db     16,-72,0
        .db     16,0,16
        .db     0
        .dw     zigzag_loop

huge_oval_pattern:
        .db     32,0,19
huge_oval_loop:
        .db     64,20,0
        .db     10,16,0
        .db     8,12,-12
        .db     28,0,-12
        .db     8,-12,-12
        .db     10,-16,0
        .db     64,-20,0
        .db     10,-16,0
        .db     8,-12,12
        .db     28,0,12
        .db     8,12,12
        .db     10,16,0
        .db     0
        .dw     huge_oval_loop

;     KKK            EEE
;    L   JJ        DD   F
;   L      JJ    DD      F
;| A         JJDD         G |
;| A         DDJJ         G |
;v A       DD    JJ       G v
;   B    DD        JJ    H
;    BCCC            IIIH

figure_eight_pattern:
        .db     32,0,12
figure_eight_loop:
        .db     12,12,12        ;B
        .db     16,16,0         ;C
        .db     34,16,-12       ;D
        .db     16,15,0         ;E
        .db     12,12,12        ;F
        .db     8,0,12          ;G
        .db     12,-12,12       ;H
        .db     16,-15,0        ;I
        .db     34,-16,-12      ;J
        .db     16,-16,0        ;K
        .db     12,-12,12       ;L
        .db     8,0,12          ;A
        .db     0
        .dw     figure_eight_loop

circle_pattern:
        .db     32,0,14
circle_loop:
        .db     8,12,12
        .db     16,64,0
        .db     8,12,-12
        .db     16,0,-16
        .db     8,-12,-12
        .db     16,-64,0
        .db     8,-12,12
        .db     16,0,16
        .db     8,12,12
        .db     16,64,0
        .db     8,12,-12
        .db     16,0,-16
        .db     8,-12,-12
        .db     16,-64,0
        .db     8,-12,12
        .db     16,0,16
        .db     0
        .dw     circle_loop

oval_pattern:
        .db     32,0,16
oval_loop:
        .db     4,12,12
        .db     76,16,0
        .db     4,12,-12
        .db     6,0,-16
        .db     4,-12,-12
        .db     76,-16,0
        .db     4,-12,12
        .db     6,0,16
        .db     0
        .dw     oval_loop


;------- Images

img_bomber:
        .db     8,8
        .db     %01111110
        .db     %10111001
        .db     %10100101
        .db     %10111001
        .db     %10100101
        .db     %10111001
        .db     %01111110

img_enemy_1:
	.db 8,8
	.db %11111111
	.db %11111111
	.db %01111110
	.db %01111110
	.db %00111100
	.db %00111100
	.db %00011000

img_enemy_2:
        .db     8,8
        .db     %11111111
        .db     %10111101
        .db     %10011001
        .db     %11011011
        .db     %11100111
        .db     %10111101
        .db     %11000011
        .db     %01111110

img_enemy_3:
	.db 7,7
	.db %00010000
	.db %00111000
	.db %11111110
	.db %01111100
	.db %01111100
	.db %10000010
	.db %00000000

img_enemy_4:
        .db     8,8
        .db     %11111111
        .db     %10111101
        .db     %10011001
        .db     %11011011
        .db     %11111111
        .db     %11000011
        .db     %10111101
        .db     %01111110

img_enemy_5:
        .db     8,8
        .db     %11111111
        .db     %10111101
        .db     %10011001
        .db     %11011011
        .db     %11100111
        .db     %11111111
        .db     %11000011
        .db     %01111110


boss1:  
        .db     16,10
        .db     %00000001
        .db     %00000010
        .db     %00000010
        .db     %00011111
        .db     %00111111
        .db     %01111111
        .db     %10010010
        .db     %01111111
        .db     %00100001
        .db     %00011111
		.db     8,10
        .db     %10000000
        .db     %01000000
        .db     %01000000
        .db     %11111000
        .db     %11111100
        .db     %11111110
        .db     %01001001
        .db     %11111110
        .db     %10000100
        .db     %11111000
       
deathboss:  
        .db     16,10
        .db     %01000011
        .db     %10111100
        .db     %01111001
        .db     %01110011
        .db     %10110111
        .db     %10110111
        .db     %01110011
        .db     %01111001
        .db     %10111100
        .db     %01000011
        .db     8,10
        .db     %11000010
        .db     %00111101
        .db     %10011110
        .db     %11001110
        .db     %11101101
        .db     %11101101
        .db     %11001110
        .db     %10011110
        .db     %00111101
        .db     %11000010
